#{{{  File banner
# @(#)=====================================================
# @(#)  Project : PUMA ESPRIT P2701
# @(#)  Authors : Mark Debbage and Mark Hill
# @(#)            University of Southampton
#  
# @(#)    Title : Makefile for vstream.lib
# @(#)   System : VCR
# @(#) Filename : vstream.mak
# @(#)  Version : 1.1
# @(#)     Date : 6/27/91
# @(#)====================================================
#}}}
LIBRARIAN=ilibr
OCCAM=oc
LINK=ilink
CONFIG=icconf
OCONFIG=occonf
COLLECT=icollect
CC=icc
DELETE=rm
LIBOPT=
OCCOPT=
LINKOPT=
CONFOPT=
OCONFOPT=
COLLECTOPT=
COPT=

# For MSDOS :
S=\ # slash
O=/
COPY=copy
VCR=\vcr

# For UNIX :
#S=/
#O=-
#COPY=cp
#VCR=/home/cougar/md/parc/upr

##### IMAKEF CUT #####

all: $(VCR)$(S)libs$(S)vstream.lib hostio.lib

hostio.lib: $(VCR)$(S)libs$(S)vhostio.lib
	$(COPY) $(VCR)$(S)libs$(S)vhostio.lib hostio.lib

$(VCR)$(S)libs$(S)vstream.lib: vstream.lbb keyscr.t8h keyscr.t8x keyscr.tah keyscr.tax \
             keysink.t8h keysink.t8x keysink.tah keysink.tax kfile.t8h \
             kfile.t8x kfile.tah kfile.tax kkbd.t8h kkbd.t8x kkbd.tah kkbd.tax \
             kstdin.t8h kstdin.t8x kstdin.tah kstdin.tax scrcont.t8h \
             scrcont.t8x scrcont.tah scrcont.tax scrcopy.t8h scrcopy.t8x \
             scrcopy.tah scrcopy.tax scrfan.t8h scrfan.t8x scrfan.tah \
             scrfan.tax scrmux.t8h scrmux.t8x scrmux.tah scrmux.tax \
             scrsink.t8h scrsink.t8x scrsink.tah scrsink.tax scrtfarr.t8h \
             scrtfarr.t8x scrtfarr.tah scrtfarr.tax sfile.t8h sfile.t8x \
             sfile.tah sfile.tax srchar.t8h srchar.t8x srchar.tah srchar.tax \
             srint.t8h srint.t8x srint.tah srint.tax srint64.t8h srint64.t8x \
             srint64.tah srint64.tax srreal32.t8h srreal32.t8x srreal32.tah \
             srreal32.tax srreal64.t8h srreal64.t8x srreal64.tah srreal64.tax \
             sstdout.t8h sstdout.t8x sstdout.tah sstdout.tax swint.t8h \
             swint.t8x swint.tah swint.tax swint64.t8h swint64.t8x swint64.tah \
             swint64.tax swreal32.t8h swreal32.t8x swreal32.tah swreal32.tax \
             swreal64.t8h swreal64.t8x swreal64.tah swreal64.tax swsimple.t8h \
             swsimple.t8x swsimple.tah swsimple.tax toansi.t8h toansi.t8x \
             toansi.tah toansi.tax totvi.t8h totvi.t8x totvi.tah totvi.tax 
	$(LIBRARIAN) $Of vstream.lbb  $Oo $(VCR)$(S)libs$(S)vstream.lib $(LIBOPT)

keyscr.t8h: keyscr.occ streamio.inc 
	$(OCCAM) keyscr $Ot8 $Oh $Oo keyscr.t8h $(OCCOPT)

keyscr.t8x: keyscr.occ streamio.inc 
	$(OCCAM) keyscr $Ot8 $Ox $Oo keyscr.t8x $(OCCOPT)

keyscr.tah: keyscr.occ streamio.inc 
	$(OCCAM) keyscr $Ota $Oh $Oo keyscr.tah $(OCCOPT)

keyscr.tax: keyscr.occ streamio.inc 
	$(OCCAM) keyscr $Ota $Ox $Oo keyscr.tax $(OCCOPT)

keysink.t8h: keysink.occ streamio.inc 
	$(OCCAM) keysink $Ot8 $Oh $Oo keysink.t8h $(OCCOPT)

keysink.t8x: keysink.occ streamio.inc 
	$(OCCAM) keysink $Ot8 $Ox $Oo keysink.t8x $(OCCOPT)

keysink.tah: keysink.occ streamio.inc 
	$(OCCAM) keysink $Ota $Oh $Oo keysink.tah $(OCCOPT)

keysink.tax: keysink.occ streamio.inc 
	$(OCCAM) keysink $Ota $Ox $Oo keysink.tax $(OCCOPT)

kfile.t8h: kfile.occ streamio.inc hostio.lib
	$(OCCAM) kfile $Ot8 $Oh $Oo kfile.t8h $(OCCOPT)

kfile.t8x: kfile.occ streamio.inc hostio.lib 
	$(OCCAM) kfile $Ot8 $Ox $Oo kfile.t8x $(OCCOPT)

kfile.tah: kfile.occ streamio.inc hostio.lib 
	$(OCCAM) kfile $Ota $Oh $Oo kfile.tah $(OCCOPT)

kfile.tax: kfile.occ streamio.inc hostio.lib
	$(OCCAM) kfile $Ota $Ox $Oo kfile.tax $(OCCOPT)

kkbd.t8h: kkbd.occ streamio.inc hostio.lib
	$(OCCAM) kkbd $Ot8 $Oh $Oo kkbd.t8h $(OCCOPT)

kkbd.t8x: kkbd.occ streamio.inc hostio.lib
	$(OCCAM) kkbd $Ot8 $Ox $Oo kkbd.t8x $(OCCOPT)

kkbd.tah: kkbd.occ streamio.inc hostio.lib
	$(OCCAM) kkbd $Ota $Oh $Oo kkbd.tah $(OCCOPT)

kkbd.tax: kkbd.occ streamio.inc hostio.lib
	$(OCCAM) kkbd $Ota $Ox $Oo kkbd.tax $(OCCOPT)

kstdin.t8h: kstdin.occ streamio.inc hostio.lib
	$(OCCAM) kstdin $Ot8 $Oh $Oo kstdin.t8h $(OCCOPT)

kstdin.t8x: kstdin.occ streamio.inc hostio.lib
	$(OCCAM) kstdin $Ot8 $Ox $Oo kstdin.t8x $(OCCOPT)

kstdin.tah: kstdin.occ streamio.inc hostio.lib
	$(OCCAM) kstdin $Ota $Oh $Oo kstdin.tah $(OCCOPT)

kstdin.tax: kstdin.occ streamio.inc hostio.lib
	$(OCCAM) kstdin $Ota $Ox $Oo kstdin.tax $(OCCOPT)

scrcont.t8h: scrcont.occ streamio.inc 
	$(OCCAM) scrcont $Ot8 $Oh $Oo scrcont.t8h $(OCCOPT)

scrcont.t8x: scrcont.occ streamio.inc 
	$(OCCAM) scrcont $Ot8 $Ox $Oo scrcont.t8x $(OCCOPT)

scrcont.tah: scrcont.occ streamio.inc 
	$(OCCAM) scrcont $Ota $Oh $Oo scrcont.tah $(OCCOPT)

scrcont.tax: scrcont.occ streamio.inc 
	$(OCCAM) scrcont $Ota $Ox $Oo scrcont.tax $(OCCOPT)

scrcopy.t8h: scrcopy.occ streamio.inc 
	$(OCCAM) scrcopy $Ot8 $Oh $Oo scrcopy.t8h $(OCCOPT)

scrcopy.t8x: scrcopy.occ streamio.inc 
	$(OCCAM) scrcopy $Ot8 $Ox $Oo scrcopy.t8x $(OCCOPT)

scrcopy.tah: scrcopy.occ streamio.inc 
	$(OCCAM) scrcopy $Ota $Oh $Oo scrcopy.tah $(OCCOPT)

scrcopy.tax: scrcopy.occ streamio.inc 
	$(OCCAM) scrcopy $Ota $Ox $Oo scrcopy.tax $(OCCOPT)

scrfan.t8h: scrfan.occ streamio.inc 
	$(OCCAM) scrfan $Ot8 $Oh $Oo scrfan.t8h $(OCCOPT)

scrfan.t8x: scrfan.occ streamio.inc 
	$(OCCAM) scrfan $Ot8 $Ox $Oo scrfan.t8x $(OCCOPT)

scrfan.tah: scrfan.occ streamio.inc 
	$(OCCAM) scrfan $Ota $Oh $Oo scrfan.tah $(OCCOPT)

scrfan.tax: scrfan.occ streamio.inc 
	$(OCCAM) scrfan $Ota $Ox $Oo scrfan.tax $(OCCOPT)

scrmux.t8h: scrmux.occ streamio.inc 
	$(OCCAM) scrmux $Ot8 $Oh $Oo scrmux.t8h $(OCCOPT)

scrmux.t8x: scrmux.occ streamio.inc 
	$(OCCAM) scrmux $Ot8 $Ox $Oo scrmux.t8x $(OCCOPT)

scrmux.tah: scrmux.occ streamio.inc 
	$(OCCAM) scrmux $Ota $Oh $Oo scrmux.tah $(OCCOPT)

scrmux.tax: scrmux.occ streamio.inc 
	$(OCCAM) scrmux $Ota $Ox $Oo scrmux.tax $(OCCOPT)

scrsink.t8h: scrsink.occ streamio.inc 
	$(OCCAM) scrsink $Ot8 $Oh $Oo scrsink.t8h $(OCCOPT)

scrsink.t8x: scrsink.occ streamio.inc 
	$(OCCAM) scrsink $Ot8 $Ox $Oo scrsink.t8x $(OCCOPT)

scrsink.tah: scrsink.occ streamio.inc 
	$(OCCAM) scrsink $Ota $Oh $Oo scrsink.tah $(OCCOPT)

scrsink.tax: scrsink.occ streamio.inc 
	$(OCCAM) scrsink $Ota $Ox $Oo scrsink.tax $(OCCOPT)

scrtfarr.t8h: scrtfarr.occ streamio.inc 
	$(OCCAM) scrtfarr $Ot8 $Oh $Oo scrtfarr.t8h $(OCCOPT)

scrtfarr.t8x: scrtfarr.occ streamio.inc 
	$(OCCAM) scrtfarr $Ot8 $Ox $Oo scrtfarr.t8x $(OCCOPT)

scrtfarr.tah: scrtfarr.occ streamio.inc 
	$(OCCAM) scrtfarr $Ota $Oh $Oo scrtfarr.tah $(OCCOPT)

scrtfarr.tax: scrtfarr.occ streamio.inc 
	$(OCCAM) scrtfarr $Ota $Ox $Oo scrtfarr.tax $(OCCOPT)

sfile.t8h: sfile.occ streamio.inc hostio.lib
	$(OCCAM) sfile $Ot8 $Oh $Oo sfile.t8h $(OCCOPT)

sfile.t8x: sfile.occ streamio.inc hostio.lib
	$(OCCAM) sfile $Ot8 $Ox $Oo sfile.t8x $(OCCOPT)

sfile.tah: sfile.occ streamio.inc hostio.lib
	$(OCCAM) sfile $Ota $Oh $Oo sfile.tah $(OCCOPT)

sfile.tax: sfile.occ streamio.inc hostio.lib
	$(OCCAM) sfile $Ota $Ox $Oo sfile.tax $(OCCOPT)

srchar.t8h: srchar.occ streamio.inc 
	$(OCCAM) srchar $Ot8 $Oh $Oo srchar.t8h $(OCCOPT)

srchar.t8x: srchar.occ streamio.inc 
	$(OCCAM) srchar $Ot8 $Ox $Oo srchar.t8x $(OCCOPT)

srchar.tah: srchar.occ streamio.inc 
	$(OCCAM) srchar $Ota $Oh $Oo srchar.tah $(OCCOPT)

srchar.tax: srchar.occ streamio.inc 
	$(OCCAM) srchar $Ota $Ox $Oo srchar.tax $(OCCOPT)

srint.t8h: srint.occ streamio.inc 
	$(OCCAM) srint $Ot8 $Oh $Oo srint.t8h $(OCCOPT)

srint.t8x: srint.occ streamio.inc 
	$(OCCAM) srint $Ot8 $Ox $Oo srint.t8x $(OCCOPT)

srint.tah: srint.occ streamio.inc 
	$(OCCAM) srint $Ota $Oh $Oo srint.tah $(OCCOPT)

srint.tax: srint.occ streamio.inc 
	$(OCCAM) srint $Ota $Ox $Oo srint.tax $(OCCOPT)

srint64.t8h: srint64.occ streamio.inc 
	$(OCCAM) srint64 $Ot8 $Oh $Oo srint64.t8h $(OCCOPT)

srint64.t8x: srint64.occ streamio.inc 
	$(OCCAM) srint64 $Ot8 $Ox $Oo srint64.t8x $(OCCOPT)

srint64.tah: srint64.occ streamio.inc 
	$(OCCAM) srint64 $Ota $Oh $Oo srint64.tah $(OCCOPT)

srint64.tax: srint64.occ streamio.inc 
	$(OCCAM) srint64 $Ota $Ox $Oo srint64.tax $(OCCOPT)

srreal32.t8h: srreal32.occ streamio.inc 
	$(OCCAM) srreal32 $Ot8 $Oh $Oo srreal32.t8h $(OCCOPT)

srreal32.t8x: srreal32.occ streamio.inc 
	$(OCCAM) srreal32 $Ot8 $Ox $Oo srreal32.t8x $(OCCOPT)

srreal32.tah: srreal32.occ streamio.inc 
	$(OCCAM) srreal32 $Ota $Oh $Oo srreal32.tah $(OCCOPT)

srreal32.tax: srreal32.occ streamio.inc 
	$(OCCAM) srreal32 $Ota $Ox $Oo srreal32.tax $(OCCOPT)

srreal64.t8h: srreal64.occ streamio.inc 
	$(OCCAM) srreal64 $Ot8 $Oh $Oo srreal64.t8h $(OCCOPT)

srreal64.t8x: srreal64.occ streamio.inc 
	$(OCCAM) srreal64 $Ot8 $Ox $Oo srreal64.t8x $(OCCOPT)

srreal64.tah: srreal64.occ streamio.inc 
	$(OCCAM) srreal64 $Ota $Oh $Oo srreal64.tah $(OCCOPT)

srreal64.tax: srreal64.occ streamio.inc 
	$(OCCAM) srreal64 $Ota $Ox $Oo srreal64.tax $(OCCOPT)

sstdout.t8h: sstdout.occ streamio.inc hostio.lib
	$(OCCAM) sstdout $Ot8 $Oh $Oo sstdout.t8h $(OCCOPT)

sstdout.t8x: sstdout.occ streamio.inc hostio.lib
	$(OCCAM) sstdout $Ot8 $Ox $Oo sstdout.t8x $(OCCOPT)

sstdout.tah: sstdout.occ streamio.inc hostio.lib
	$(OCCAM) sstdout $Ota $Oh $Oo sstdout.tah $(OCCOPT)

sstdout.tax: sstdout.occ streamio.inc hostio.lib
	$(OCCAM) sstdout $Ota $Ox $Oo sstdout.tax $(OCCOPT)

swint.t8h: swint.occ streamio.inc 
	$(OCCAM) swint $Ot8 $Oh $Oo swint.t8h $(OCCOPT)

swint.t8x: swint.occ streamio.inc 
	$(OCCAM) swint $Ot8 $Ox $Oo swint.t8x $(OCCOPT)

swint.tah: swint.occ streamio.inc 
	$(OCCAM) swint $Ota $Oh $Oo swint.tah $(OCCOPT)

swint.tax: swint.occ streamio.inc 
	$(OCCAM) swint $Ota $Ox $Oo swint.tax $(OCCOPT)

swint64.t8h: swint64.occ streamio.inc 
	$(OCCAM) swint64 $Ot8 $Oh $Oo swint64.t8h $(OCCOPT)

swint64.t8x: swint64.occ streamio.inc 
	$(OCCAM) swint64 $Ot8 $Ox $Oo swint64.t8x $(OCCOPT)

swint64.tah: swint64.occ streamio.inc 
	$(OCCAM) swint64 $Ota $Oh $Oo swint64.tah $(OCCOPT)

swint64.tax: swint64.occ streamio.inc 
	$(OCCAM) swint64 $Ota $Ox $Oo swint64.tax $(OCCOPT)

swreal32.t8h: swreal32.occ streamio.inc 
	$(OCCAM) swreal32 $Ot8 $Oh $Oo swreal32.t8h $(OCCOPT)

swreal32.t8x: swreal32.occ streamio.inc 
	$(OCCAM) swreal32 $Ot8 $Ox $Oo swreal32.t8x $(OCCOPT)

swreal32.tah: swreal32.occ streamio.inc 
	$(OCCAM) swreal32 $Ota $Oh $Oo swreal32.tah $(OCCOPT)

swreal32.tax: swreal32.occ streamio.inc 
	$(OCCAM) swreal32 $Ota $Ox $Oo swreal32.tax $(OCCOPT)

swreal64.t8h: swreal64.occ streamio.inc 
	$(OCCAM) swreal64 $Ot8 $Oh $Oo swreal64.t8h $(OCCOPT)

swreal64.t8x: swreal64.occ streamio.inc 
	$(OCCAM) swreal64 $Ot8 $Ox $Oo swreal64.t8x $(OCCOPT)

swreal64.tah: swreal64.occ streamio.inc 
	$(OCCAM) swreal64 $Ota $Oh $Oo swreal64.tah $(OCCOPT)

swreal64.tax: swreal64.occ streamio.inc 
	$(OCCAM) swreal64 $Ota $Ox $Oo swreal64.tax $(OCCOPT)

swsimple.t8h: swsimple.occ streamio.inc 
	$(OCCAM) swsimple $Ot8 $Oh $Oo swsimple.t8h $(OCCOPT)

swsimple.t8x: swsimple.occ streamio.inc 
	$(OCCAM) swsimple $Ot8 $Ox $Oo swsimple.t8x $(OCCOPT)

swsimple.tah: swsimple.occ streamio.inc 
	$(OCCAM) swsimple $Ota $Oh $Oo swsimple.tah $(OCCOPT)

swsimple.tax: swsimple.occ streamio.inc 
	$(OCCAM) swsimple $Ota $Ox $Oo swsimple.tax $(OCCOPT)

toansi.t8h: toansi.occ streamio.inc hostio.lib
	$(OCCAM) toansi $Ot8 $Oh $Oo toansi.t8h $(OCCOPT)

toansi.t8x: toansi.occ streamio.inc hostio.lib
	$(OCCAM) toansi $Ot8 $Ox $Oo toansi.t8x $(OCCOPT)

toansi.tah: toansi.occ streamio.inc hostio.lib
	$(OCCAM) toansi $Ota $Oh $Oo toansi.tah $(OCCOPT)

toansi.tax: toansi.occ streamio.inc hostio.lib
	$(OCCAM) toansi $Ota $Ox $Oo toansi.tax $(OCCOPT)

totvi.t8h: totvi.occ streamio.inc hostio.lib
	$(OCCAM) totvi $Ot8 $Oh $Oo totvi.t8h $(OCCOPT)

totvi.t8x: totvi.occ streamio.inc hostio.lib
	$(OCCAM) totvi $Ot8 $Ox $Oo totvi.t8x $(OCCOPT)

totvi.tah: totvi.occ streamio.inc hostio.lib
	$(OCCAM) totvi $Ota $Oh $Oo totvi.tah $(OCCOPT)

totvi.tax: totvi.occ streamio.inc hostio.lib
	$(OCCAM) totvi $Ota $Ox $Oo totvi.tax $(OCCOPT)

